/*
NAME: 
DESCRIPTION: 打断连接肋;
PARAMETER:
	[
		{
			name : 'step',
			title : 'step',
			type : 'LineEdit',
			property : {tool_tip : '目标step,默认是orig'}
		},
        {
			name : 'workLayers',
			title : 'workLayers',
			type : 'LineEdit',
			property : {tool_tip : '工作层'}
		},
		{
			name : 'auto_save',
			title : '自动保存',
			type : 'RadioBox',
			property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
		}
	]
	
 VERSION_HISTORY:
	V1.00 2021-04-08 template
		1.新版本
		
 HELP:
	  <html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> template </ p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> 线段转弧 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/

// 引入模块 包 外部参数
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
var _ = require('lodash');
var mode = $.ikm ? "topcam" : "aimdfm";
var IKM = $.ikm ? $.ikm : require('topcam.ikm6')($);
var GEN = $.gen;
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db;
var plugin = require('topsin.gengui');
var GUI = plugin.newGui(plugin.__dirname);
var PAR = {};
if ($.par) {
	PAR = $.par;
} else if ($.hasOwnProperty('script_parameter')) {
	PAR = JSON.parse($.script_parameter);
}
if (mode === "aimdfm") {
	IKM.crud("updateRow", {
		table: "pdm_aimdfm_task",
		data: { current_process_title: $.process_title },
		where: { id: $.task_id }
	});
}
var Status = 'ok';
var resultData = [];
var par = PAR; // 接收参数
var default_par = { // 设置默认参数
	step: "cad",
	auto_save: "No",
    workLayers:"out",
	units: "mm"
};
for (var key in default_par) {
	if (!par.hasOwnProperty(key) || par[key] == "") {
		par[key] = default_par[key];
	}
}

// 定义变量
var job = Job.toLowerCase();
require("topsin.genmath");
var genMath = new GenMath();
try {
	// 常规验证 准备工作
	if (!GEN.isJobExists({ job: job })) { throw "料号" + job + "不存在" }
	if (!GEN.isJobOpen({ job: job })) { GEN.openJob({ job: job }) }
	if (mode == "aimdfm") {
		if (GEN.checkInout({job: job,mode: "test"}) != 0) {
			throw "the job check"
		}
		GEN.checkInout({job: job,mode: "out"});
	}
	// 主体
	var stepList = GEN.getStepList({ job: job });
	stepList = stepList.filter(function (v) {
		var tmpreg = new RegExp(par.step, "ig");
		return tmpreg.test(v);
	});
	if (stepList.length == 0) {
		throw "未找到" + par.step
	}
    
    var workLayers = par.workLayers.split(";")
    workLayers = workLayers.filter(function(l){return GEN.isLayerExists({job:job, layer:l})})
    if(workLayers.length == 0) {
        throw "没有找到工作层"
    }

	var drls = getLayer({layer_type:"drill", context:"board"})
	var specialAttr = ".drill_noopt"
    stepList.forEach(function (step) {
		GEN.openStep({ job: job, name: step });
		GEN.clearLayers();  //清除层显示
		GEN.affectedLayer({ mode: 'all', affected: 'no' }); //设置影响层全部不影响
		GEN.COM("sel_options,clear_mode=clear_after,display_mode=all_layers,area_inout=inside,area_select=select,select_mode=standard,area_touching_mode=exclude");
		GEN.units({ type: par.units }); //单位初始化
		GEN.zoomHome();  //窗口显示回到原始位置
		GEN.selClearFeature()
	
		workLayers.forEach(function (layer) {
			// 前处理 将特殊钻孔和层的线弧拷贝到辅助层
			drls.forEach(function (drl) {
				GEN.workLayer({name:drl, clear_before:"yes"})
				GEN.selectByFilter({feat_types:"pad", attribute:specialAttr})
				if(GEN.getSelectCount() > 0) {
					GEN.selCopyOther({dest:"layer_name", target_layer:layer})
				}
			})

			GEN.workLayer({name:layer, clear_before:"yes"})
			delLayer(["tmp", layer+"_tmp"])

			// 1. 找特殊钻孔  计算特殊钻孔间距 小于xxx的为一组
			GEN.selectByFilter({feat_types:"pad", attribute:specialAttr})
			if(GEN.getSelectCount() > 0) {
				var feats = GEN.getFeatures({job:job, step:step, layer:layer, units:"mm", options:"select+feat_index"})
				GEN.selClearFeature()
				feats.forEach(function (feat, i1) {
					feats.forEach(function (feat2, i2) {
						if(feat.index != feat2.index && i2 > i1) {
							var p2p = Math.sqrt((feat2.x - feat.x)*(feat2.x - feat.x) + (feat2.y - feat.y)*(feat2.y - feat.y))
							if(p2p > 2 && p2p < 5) {
								GEN.workLayer({name:layer, clear_before:"yes"})
								GEN.selLayerFeat({layer:layer, index:feat.index,operation:"select"})
								GEN.selLayerFeat({layer:layer, index:feat2.index,operation:"select"})
								GEN.selCopyOther({dest:"layer_name", target_layer:"tmp", size: 2000})
								GEN.workLayer({name:"tmp", clear_before:"yes"})
								GEN.selRefFeat({layers: layer, use:"filter", mode:"touch"})
								if(GEN.getSelectCount() > 0) {
									var line = {xs:feat.x-0, ys:feat.y-0, xe:feat2.x-0, ye: feat2.y-0, symbol:"r10" }
									var lineLen = p2p
									var k = (line.xe-line.xs)/(line.ye-line.ys)
									var q = (line.ye-line.ys)/(line.xe-line.xs)
									var lineCenter = {
										x: (line.xe-line.xs)/2 + line.xs,
										y: (line.ye-line.ys)/2 + line.ys
									}
									GEN.addLine(line);
									GEN.selectByFilter({feat_types:"line"})
									GEN.COM("sel_transform,mode=anchor,oper=rotate,duplicate=no,x_anchor="+lineCenter.x+",y_anchor="+lineCenter.y
									+",angle=90,x_scale=1,y_scale=1,x_offset=0,y_offset=0")
									GEN.selectByFilter({feat_types:"line"})
									GEN.selReverse()
									if(GEN.getSelectCount() > 0) {
										GEN.selDelete()
									}
									GEN.workLayer({name:layer, clear_before:"yes"})
									GEN.selectByFilter({attribute:".imp_line"})
									if(GEN.getSelectCount() > 0) {
										GEN.selDelete()
									}
									GEN.selRefFeat({layers:"tmp", use:"filter", mode:"touch"})
									GEN.selectByFilter({feat_types:"pad\;text\;arc\;surface", operation:"unselect"})
									if(GEN.getSelectCount() > 0) {
										var lines=GEN.getFeatures({job:job, step:step, layer:layer, units:"mm", options:"select+feat_index"})
										// 获取ines里面最大的symbol
										var ls = [];
										lines.forEach(function (l) {
											var p2l = p2line(lineCenter.x, lineCenter.y, l.xs,l.ys,l.xe,l.ye)
											if (p2l > 0.001) {
												var xmid = l.xs + (l.xe - l.xs) / 2
												var ymid = l.ys + (l.ye - l.ys) / 2
												ls.push({
													p2l:p2l, l:l,
													symbol: l.symbol,
													xmid:xmid, ymid:ymid
												})
											}
										})
										GEN.selClearFeature()
										if(ls && ls.length) {
											ls.forEach(function (lsv) {
												var length = lsv.p2l
												var line = {xs:feat.x-0, ys:feat.y-0, xe:feat2.x-0, ye: feat2.y-0, symbol:lsv.symbol }
												var yChange = (line.xe-line.xs)*(length/p2p)
												var xChange = (line.ye-line.ys)*(length/p2p)
												GEN.addLine({xs:feat.x-0+xChange, ys:feat.y-0+yChange, xe:feat2.x-0+xChange, ye: feat2.y-0+yChange, symbol:"r420" , attributes:".imp_line"});
												GEN.addLine({xs:feat.x-0-xChange, ys:feat.y-0-yChange, xe:feat2.x-0-xChange, ye: feat2.y-yChange, symbol:"r420" , attributes:".imp_line"});	
											})
											GEN.selectByFilter({attribute:".imp_line"})
											GEN.selRefFeat({layers:layer, use:"select", mode:"cover"})
											GEN.selectByFilter({feat_types:"pad\;text\;arc\;surface", operation:"unselect"})
											if(GEN.getSelectCount() > 0) {
												GEN.selMoveOther({target_layer:layer+"_tmp"})
											}
											GEN.selectByFilter({attribute:".imp_line"})
											if(GEN.getSelectCount() > 0) {
												GEN.selDelete()
											}
											// todo ls 循环 incam特殊命令点选
											ls.forEach(function (lsv) {
												var xmid = lsv.xmid
												var ymid = lsv.ymid
												GEN.COM("sel_single_feat,operation=select,x="+xmid+",y="+ymid+",cyclic=yes") 
											})

										}

									}
								}
							}
						}
					})
				})
				GEN.workLayer({name:layer, clear_before:"yes"})
				GEN.selectByFilter({feat_types:"pad", attribute:specialAttr})
				if(GEN.getSelectCount() > 0) {
					GEN.selDelete()
				}
			}


			// 2. 遍历特殊钻孔组 放大xxtouch线弧 钻孔相连 画2平行辅助线
			// 3. 辅助线完全覆盖的线 且斜率差不多的 删除
			// 4. incam特殊用法点击辅助线中点

		})

		// GEN.affectedLayer({ mode: 'all', affected: 'no' }); //设置影响层全部不影响
		// GEN.clearLayers();  //清除层显示
	});

	// 保存料号
	if (/yes/ig.test(par.auto_save)) {
		GEN.checkInout({ job: job, mode: "out" });
		GEN.saveJob({ job: job });
		GEN.checkInout({ job: job, mode: "in" });
	}

	// 结尾返回  固定写法
	var Return = "Done";
	if (mode === "aimdfm") {
		IKM.crud("updateRow", {
			table: "pdm_aimdfm_task",
			data: { progress: 100 },
			where: { id: $.task_id }
		});
		var tmperr = { type: "info", title: "操作完成, 请注意检查!" };
		if (GEN.hasError()) {
			Status = 'error';
			tmperr = { type: "error", title: "GEN错误!", detail: [{ desc: GEN.STATUS.join("\n") }] };
		}
		resultData.push(tmperr);
		Return = { status: Status, result_data: resultData };
	}
	return Return;
} catch (e) {
	var showGUI = true;
	if (GEN.STATUS.length > 0) {
		if (GEN.STATUS.indexOf("Pause Exit:0") >= 0) {
			showGUI = false;
		}
		e = _.toString(e) + "\n" + GEN.STATUS.join("\n");
	}
	if (showGUI) {
		IKM.msg(e);
	}
	Status = 'error';
	resultData.push({ type: "error", title: "脚本执行出错!", detail: [{ desc: _.toString(e) }] });
	return mode === "aimdfm" ? { status: Status, result_data: resultData } : "Error";
}

/**
 * 获取层别
 * @param {Object} 过滤选项
 * @returns {Array}
 */
function getLayer(props) {
	if (!props) {
		props = {};
	}
	var matrix = GEN.getMatrix({ job: job });
	return Object.keys(matrix).reduce(function (a, b) {
		var info = matrix[b];
		var ret = true;
		for (var _key in props) {
			if (info[_key]) {
				if (/object string|object number/ig.test({}.toString.call(props[_key]))) {
					if (props[_key] != info[_key]) {
						ret = false;
					}
				}
				if (/object RegExp/ig.test({}.toString.call(props[_key]))) {
					if (!props[_key].test(info[_key])) {
						ret = false;
					}
				}
				if (/object function/ig.test({}.toString.call(props[_key]))) {
					if (!props[_key](info[_key])) {
						ret = false;
					}
				}
			}
		}
		if (ret) {
			a.push(props.res == "info" ? info : b);
		}
		return a;
	}, []);
}

/**
 * 
 * @param {*} layer 
 */
 function delLayer(layer){
	if(!Array.isArray(layer)){
		layer = [layer]
	}
	layer = layer.filter(function(v){return GEN.isLayerExists({job:job, layer:v})})
	if(layer.length > 0){
		GEN.deleteLayer({job:job, layer:layer})
	}
}


function p2line(x, y, x1, y1, x2, y2) {
    var A = Math.abs(Math.sqrt(Math.pow((x - x1), 2) + Math.pow((y - y1), 2))); 
	var B = Math.abs(Math.sqrt(Math.pow((x - x2), 2) + Math.pow((y - y2), 2))); 
	var C = Math.abs(Math.sqrt(Math.pow((x1 - x2), 2) + Math.pow((y1 - y2), 2))); //利用海伦公式计算三角形面积 //周长的一半 
    var P = (A + B + C) / 2; 
	var allArea = Math.abs(Math.sqrt(P * (P - A) * (P - B) * (P - C))); //普通公式计算三角形面积反推点到线的垂直距离 
    var dis = (2 * allArea) / C; 
	return dis;
}