/*
NAME: 
DESCRIPTION: 连接位修复;
PARAMETER:
	[
		{
			name : 'step',
			title : 'step',
			type : 'LineEdit',
			property : {tool_tip : '目标step,默认是orig'}
		},
        {
			name : 'workLayers',
			title : 'workLayers',
			type : 'LineEdit',
			property : {tool_tip : '工作层'}
		},
		{
			name : 'auto_save',
			title : '自动保存',
			type : 'RadioBox',
			property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
		}
	]
	
 VERSION_HISTORY:
	V1.00 2021-04-08 template
		1.新版本
		
 HELP:
	  <html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> template </ p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> 连接位修复 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/

// 引入模块 包 外部参数
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
var _ = require('lodash');
var mode = $.ikm ? "topcam" : "aimdfm";
var IKM = $.ikm ? $.ikm : require('topcam.ikm6')($);
var GEN = $.gen;
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db;
var plugin = require('topsin.gengui');
var GUI = plugin.newGui(plugin.__dirname);
var PAR = {};
if ($.par) {
	PAR = $.par;
} else if ($.hasOwnProperty('script_parameter')) {
	PAR = JSON.parse($.script_parameter);
}
if (mode === "aimdfm") {
	IKM.crud("updateRow", {
		table: "pdm_aimdfm_task",
		data: { current_process_title: $.process_title },
		where: { id: $.task_id }
	});
}
var Status = 'ok';
var resultData = [];
var par = PAR; // 接收参数
var default_par = { // 设置默认参数
	step: "cad",
	auto_save: "No",
    workLayers:"out",
	units: "mm"
};
for (var key in default_par) {
	if (!par.hasOwnProperty(key) || par[key] == "") {
		par[key] = default_par[key];
	}
}

// 定义变量
var job = Job.toLowerCase();
require("topsin.genmath");
var genMath = new GenMath();
try {
	// 常规验证 准备工作
	if (!GEN.isJobExists({ job: job })) { throw "料号" + job + "不存在" }
	if (!GEN.isJobOpen({ job: job })) { GEN.openJob({ job: job }) }
	if (mode == "aimdfm") {
		if (GEN.checkInout({job: job,mode: "test"}) != 0) {
			throw "the job check"
		}
		GEN.checkInout({job: job,mode: "out"});
	}
	// 主体
	var stepList = GEN.getStepList({ job: job });
	stepList = stepList.filter(function (v) {
		var tmpreg = new RegExp(par.step, "ig");
		return tmpreg.test(v);
	});
	if (stepList.length == 0) {
		throw "未找到" + par.step
	}
    
    var workLayers = par.workLayers.split(";")
    workLayers = workLayers.filter(function(l){return GEN.isLayerExists({job:job, layer:l})})
    if(workLayers.length == 0) {
        throw "没有找到工作层"
    }

    var func = 'function(props){return GUI.showForm({\
		title: "连接位公差(um)",\
		size: "400x220",\
		use_core_engine: true,\
		include_hidden_items: true,\
		items: {\
			type: "ScrollArea",\
			property: {\
				widget_resizable: true,\
				frame_shape: "NoFrame"\
			},\
			child: [{\
				type: "FormGridLayout",\
				property: {\
				},\
				child: [{\
					name : "tolerance",\
					title: "tolerance",\
					type : "LineEdit",\
					property : {tool_tip : "tolerance"}\
				}]\
			}]\
		},\
		values: { tolerance: 200 },\
	}) }';


	var data = IKM.command(func, {}, 1).data;
	if(data && data.tolerance && /\d/.test(data.tolerance) ){
        stepList.forEach(function (step) {
            GEN.openStep({ job: job, name: step });
            GEN.clearLayers();  //清除层显示
            GEN.affectedLayer({ mode: 'all', affected: 'no' }); //设置影响层全部不影响
            GEN.COM("sel_options,clear_mode=clear_after,display_mode=all_layers,area_inout=inside,area_select=select,select_mode=standard,area_touching_mode=exclude");
            GEN.units({ type: par.units }); //单位初始化
            // GEN.zoomHome();  //窗口显示回到原始位置
            GEN.selClearFeature()
            
            workLayers.forEach(function(layer){
                GEN.workLayer({name:layer, clear_before:"yes"})
				var retCount;
				var indexObj = {}
				var oldIndex = {}
				for (var index = 0; index < 5; index++) {
					var feats = GEN.getFeatures({job:job, step:step, layer:layer, units:"mm", options:"feat_index"})
					feats = feats.filter(function (feat) {
						return feat.type == "line" || feat.type == "arc"
					});
					if(index == 0) {
						feats.forEach(function (params) {
							oldIndex[params.index] = true
						})
					}
					var ret = [];
					var keys = {}
					feats.forEach(function (feat1, i) {
						// feat1 不要是迭代后的新index
						if(oldIndex[feat1.index]) {
							for (var i2 = i+1; i2 < feats.length; i2++) {
								var feat2 = feats[i2]
								if(feat2 && lineLength(feat1) > 0.2 && lineLength(feat2) > 0.2) {
									var len1 = PointToLineDistance(feat1.xs, feat1.ys, feat2.xs,feat2.ys,feat2.xe,feat2.ye)
									var len2 = PointToLineDistance(feat1.xe, feat1.ye, feat2.xs,feat2.ys,feat2.xe,feat2.ye)
									var len3 = PointToLineDistance(feat2.xs, feat2.ys, feat1.xs,feat1.ys,feat1.xe,feat1.ye)
									var len4 = PointToLineDistance(feat2.xe, feat2.ye, feat1.xs,feat1.ys,feat1.xe,feat1.ye)
									if((FlagTolerance(len1[0])&&!pinLine({x:feat1.xs, y:feat1.ys}, feats, [feat1.index, feat2.index])) 
									|| (FlagTolerance(len2[0])&&!pinLine({x:feat1.xe, y:feat1.ye}, feats, [feat1.index, feat2.index])) 
									|| (FlagTolerance(len3[0])&&!pinLine({x:feat2.xs, y:feat2.ys}, feats, [feat1.index, feat2.index])) 
									|| (FlagTolerance(len4[0])&&!pinLine({x:feat2.xe, y:feat2.ye}, feats, [feat1.index, feat2.index]))) {
										var key;
										if((feat1.index-0) > (feat2.index-0)) {
											key = feat1.index + "_" + feat2.index
										} else {
											key = feat2.index + "_" + feat1.index
										}
										if (!keys[key]) {
											
											keys[key] = true
											ret.push({
												feat1: feat1,
												feat2: feat2,
											})
										}
									}
								}
							}
						}
					});
					if(ret.length > 0) {
						// 1. 判断两个线是否有角度 或者是否有弧
						// 选中执行命令
						ret.forEach(function (item) {
							var feat1 = item.feat1
							var feat2 = item.feat2
							var flag = true;
							if(flag && !indexObj[feat1.index] && !indexObj[feat2.index]) {
								GEN.selLayerFeat({layer:layer, index:feat1.index,operation:"select"})
								GEN.selLayerFeat({layer:layer, index:feat2.index,operation:"select"})
								if(GEN.getSelectCount() == 2 ) {
									GEN.COM("sel_design2rout,det_tol="+data.tolerance+",con_tol="+data.tolerance+",rad_tol=10")
									indexObj[feat1.index] = true
									indexObj[feat2.index] = true
								} 
								GEN.selClearFeature()
							}
						})
					} else {
						break
					}
				}


{
				var feats = GEN.getFeatures({job:job, step:step, layer:layer, units:"mm", options:"feat_index"})
                feats = feats.filter(function (feat) {
                    return feat.type == "line" || feat.type == "arc"
                });
                var ret = [];
				var keys = {}
                feats.forEach(function (feat1, i) {
                    for (var i2 = i+1; i2 < feats.length; i2++) {
                        var feat2 = feats[i2]
                        if(feat2 && lineLength(feat1) > 0.2 && lineLength(feat2) > 0.2) {
                            var len1 = PointToLineDistance(feat1.xs, feat1.ys, feat2.xs,feat2.ys,feat2.xe,feat2.ye)
                            var len2 = PointToLineDistance(feat1.xe, feat1.ye, feat2.xs,feat2.ys,feat2.xe,feat2.ye)
                            var len3 = PointToLineDistance(feat2.xs, feat2.ys, feat1.xs,feat1.ys,feat1.xe,feat1.ye)
                            var len4 = PointToLineDistance(feat2.xe, feat2.ye, feat1.xs,feat1.ys,feat1.xe,feat1.ye)
							if((FlagTolerance(len1[0])&&!pinLine({x:feat1.xs, y:feat1.ys}, feats, [feat1.index, feat2.index], true)) 
								|| (FlagTolerance(len2[0])&&!pinLine({x:feat1.xe, y:feat1.ye}, feats, [feat1.index, feat2.index], true)) 
								|| (FlagTolerance(len3[0])&&!pinLine({x:feat2.xs, y:feat2.ys}, feats, [feat1.index, feat2.index], true)) 
								|| (FlagTolerance(len4[0])&&!pinLine({x:feat2.xe, y:feat2.ye}, feats, [feat1.index, feat2.index], true))) {
								var key;
								if((feat1.index-0) > (feat2.index-0)) {
									key = feat1.index + "_" + feat2.index
								} else {
									key = feat2.index + "_" + feat1.index
								}
								if (!keys[key]) {
									keys[key] = true
									ret.push({
										feat1: feat1,
										feat2: feat2,
									})
								}
                            }
                        }
                    }
                })
			
				GEN.selClearFeature()
				if(ret.length > 0) {
                    ret.forEach(function (item) {
                        var feat1 = item.feat1
                        var feat2 = item.feat2
						GEN.selLayerFeat({layer:layer, index:feat1.index,operation:"select"})
						GEN.selLayerFeat({layer:layer, index:feat2.index,operation:"select"})
                    })
					GEN.PAUSE("check not optimize lines")
                }
}
            })
    
            GEN.affectedLayer({ mode: 'all', affected: 'no' }); //设置影响层全部不影响
            GEN.clearLayers();  //清除层显示
        });
    }
    

    function FlagTolerance(len) {
        return len > 0.001 && len <= data.tolerance/1000
    }

	// 保存料号
	if (/yes/ig.test(par.auto_save)) {
		GEN.checkInout({ job: job, mode: "out" });
		GEN.saveJob({ job: job });
		GEN.checkInout({ job: job, mode: "in" });
	}

	// 结尾返回  固定写法
	var Return = "Done";
	if (mode === "aimdfm") {
		IKM.crud("updateRow", {
			table: "pdm_aimdfm_task",
			data: { progress: 100 },
			where: { id: $.task_id }
		});
		var tmperr = { type: "info", title: "操作完成, 请注意检查!" };
		if (GEN.hasError()) {
			Status = 'error';
			tmperr = { type: "error", title: "GEN错误!", detail: [{ desc: GEN.STATUS.join("\n") }] };
		}
		resultData.push(tmperr);
		Return = { status: Status, result_data: resultData };
	}
	return Return;
} catch (e) {
	var showGUI = true;
	if (GEN.STATUS.length > 0) {
		if (GEN.STATUS.indexOf("Pause Exit:0") >= 0) {
			showGUI = false;
		}
		e = _.toString(e) + "\n" + GEN.STATUS.join("\n");
	}
	if (showGUI) {
		IKM.msg(e);
	}
	Status = 'error';
	resultData.push({ type: "error", title: "脚本执行出错!", detail: [{ desc: _.toString(e) }] });
	return mode === "aimdfm" ? { status: Status, result_data: resultData } : "Error";
}

function lineLength(line) {
	return Math.sqrt((line.xe - line.xs)*(line.xe - line.xs) + (line.ye - line.ys)*(line.ye - line.ys))
}

/**
 * 获取层别
 * @param {Object} 过滤选项
 * @returns {Array}
 */
function getLayer(props) {
	if (!props) {
		props = {};
	}
	var matrix = GEN.getMatrix({ job: job });
	return Object.keys(matrix).reduce(function (a, b) {
		var info = matrix[b];
		var ret = true;
		for (var _key in props) {
			if (info[_key]) {
				if (/object string|object number/ig.test({}.toString.call(props[_key]))) {
					if (props[_key] != info[_key]) {
						ret = false;
					}
				}
				if (/object RegExp/ig.test({}.toString.call(props[_key]))) {
					if (!props[_key].test(info[_key])) {
						ret = false;
					}
				}
				if (/object function/ig.test({}.toString.call(props[_key]))) {
					if (!props[_key](info[_key])) {
						ret = false;
					}
				}
			}
		}
		if (ret) {
			a.push(props.res == "info" ? info : b);
		}
		return a;
	}, []);
}

function p2p(props) {
    var x1 = props.x1
    var y1 = props.y1
    var x2 = props.x2
    var y2 = props.y2
    return Math.sqrt((x2-x1) * (x2-x1) + (y2-y1) * (y2-y1)) 
}

function pinLine(p, lines, is, flag) { // 点在线上
	var line;
	var len = lines.length;
	// if(flag && is[0] == "462" && is[1] == "470") {
	// 	IKM.msg(is)
	// 	fs.writeFile("D:/vsCodeWork/test/tmp1.js", _.toString({
	// 		p:p, lines:lines, is:is
	// 	}))
	// }
	
	for (var index = 0; index < len; index++) {
		if(lines[index].index != is[0] && lines[index].index != is[1]) {
			var xs = lines[index].xs
			var ys = lines[index].ys
			var xe = lines[index].xe
			var ye = lines[index].ye
			
			if((p.x == xs && p.y ==ys) || (p.x == xe && p.y ==ye)){
				line = lines[index]
				break
			} else if(Math.abs(ye-ys) <= 0.001 && Math.abs(ye-p.y)<= 0.001) {
				line = lines[index]
				break
			} else if(Math.abs(xe-xs) <= 0.001 && Math.abs(xe-p.x)<= 0.001) {
				line = lines[index]
				break
			} else if(Math.abs((xs-xe)/(ys-ye) - (p.x-xe)/(p.y-ye)) <= 0.0001) {
				line = lines[index]
				break
			}
		}
	}
	// if(!line) {

	// 	GEN.selLayerFeat({layer:GEN.getWorkLayer(), index:is[0],operation:"select"})
	// 	GEN.selLayerFeat({layer:GEN.getWorkLayer(), index:is[1],operation:"select"})

	// 	fs.writeFile("D:/vsCodeWork/test/tmp1.js", _.toString({
	// 		p:p, lines:lines, is:is
	// 	}))


	// 	GEN.PAUSE(0)
	// 	GEN.selClearFeature()
	// }
	return line
}

function PointToLineDistance(xx, yy, x1, y1, x2, y2) {
    var ang1, ang2, ang, m;
    var result = 0;
    // 分别计算三条边的长度
    var a = Math.sqrt((x1 - xx) * (x1 - xx) + (y1 - yy) * (y1 - yy));
    if (a === 0) {
        return [0, {
            x: x1,
            y: y1
        }];
    }
    var b = Math.sqrt((x2 - xx) * (x2 - xx) + (y2 - yy) * (y2 - yy));
    if (b === 0) {
        return [0, {
            x: x2,
            y: y2
        }];
    }
    var c = Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
    // 如果线段是一个点则退出函数并返回距离
    if (c === 0) {
        result = a;
        return [result, {
            x: x1,
            y: y1
        }];

    }
    // 如果点(xx,yy到点x1,y1)这条边短
    if (a < b) {
        // 如果直线段AB是水平线。得到直线段AB的弧度
        if (y1 === y2) {
            if (x1 < x2) {
                ang1 = 0;
            } else {
                ang1 = Math.PI;
            }
        } else {
            m = (x2 - x1) / c;
            if (m - 1 > 0.00001) {
                m = 1;
            }
            ang1 = Math.acos(m);
            if (y1 > y2) {
                ang1 = Math.PI * 2 - ang1;
            }// 直线(x1,y1)-(x2,y2)与折X轴正向夹角的弧度
        }
        m = (xx - x1) / a;
        if (m - 1 > 0.00001) {
            m = 1;
        }
        ang2 = Math.acos(m);
        if (y1 > yy) {
            ang2 = Math.PI * 2 - ang2;
        }// 直线(x1,y1)-(xx,yy)与折X轴正向夹角的弧度
        ang = ang2 - ang1;
        if (ang < 0) {
            ang = -ang;
        }
        if (ang > Math.PI) {
            ang = Math.PI * 2 - ang;
        }
        // 如果是钝角则直接返回距离
        if (ang > Math.PI / 2) {
            return [a, {
                x: x1,
                y: y1
            }];
        }
        // 返回距离并且求得当前距离所在线段的坐标
        if (x1 === x2) {
            return [b * Math.sin(ang), {
                x: x1,
                y: yy
            }];
        } else if (y1 === y2) {
            return [b * Math.sin(ang), {
                x: xx,
                y: y1
            }];
        }
        // 直线的斜率存在且不为0的情况下
        var x = 0,
            y = 0;
        var k1 = ((y2 - y1) / x2 - x1);
        var kk = -1 / k1;
        var bb = yy - xx * kk;
        var b1 = y2 - x2 * k1;
        x = (b1 - bb) / (kk - k1);
        y = kk * x + bb;
        return [a * Math.sin(ang), {
            x:x,
       	 	y:y
        }];
    }
    // 如果两个点的纵坐标相同，则直接得到直线斜率的弧度
    if (y1 === y2) {
        if (x1 < x2) {
            ang1 = Math.PI;
        } else {
            ang1 = 0;
        }
    } else {
        m = (x1 - x2) / c;
        if (m - 1 > 0.00001) {
            m = 1;
        }
        ang1 = Math.acos(m);
        if (y2 > y1) {
            ang1 = Math.PI * 2 - ang1;
        }
    }
    m = (xx - x2) / b;
    if (m - 1 > 0.00001) {
        m = 1;
    }
    ang2 = Math.acos(m);// 直线(x2-x1)-(xx,yy)斜率的弧度
    if (y2 > yy) {
        ang2 = Math.PI * 2 - ang2;
    }
    ang = ang2 - ang1;
    if (ang < 0) {
        ang = -ang;
    }
    if (ang > Math.PI) {
        ang = Math.PI * 2 - ang;
    }// 交角的大小
    // 如果是对角则直接返回距离
    if (ang > Math.PI / 2) {
        return [b, {
            x: x2,
            y: y2
        }];
    }
    // 如果是锐角，返回计算得到的距离,并计算出相应的坐标
    if (x1 === x2) {
        return [b * Math.sin(ang), {
            x: x1,
            y: yy
        }];
    } else if (y1 === y2) {
        return [b * Math.sin(ang), {
            x: xx,
            y: y1
        }];
    }
    // 直线的斜率存在且不为0的情况下
    var x = 0,
        y = 0;
    var k1 = ((y2 - y1) / x2 - x1);
    var kk = -1 / k1;
    var bb = yy - xx * kk;
    var b1 = y2 - x2 * k1;
    x = (b1 - bb) / (kk - k1);
    y = kk * x + bb;
    return [b * Math.sin(ang), {
        x:x,
        y:y
    }];
}